module statelogic (next_state, Out, state, InA);

input InA;
input [2:0] state;
output [2:0] next_state;
output Out;

reg [2:0] next_state;

assign Out = state[2];


always @(InA or state)
begin
  casex({InA,state})
    4'b0_000:
      next_state <= 3'b000;
    4'b1_000:
      next_state <= 3'b001;

    4'b0_001:
      next_state <= 3'b000;
    4'b1_001:
      next_state <= 3'b010;

    4'b0_010:
      next_state <= 3'b011;
    4'b1_010:
      next_state <= 3'b010;

    4'b0_011:
      next_state <= 3'b000;
    4'b1_011:
      next_state <= 3'b100;
    
    4'b0_100:
      next_state <= 3'b000;
    4'b1_100:
      next_state <= 3'b010;
    
    default:
      next_state <= {3{1'bx}};
  endcase
end

endmodule
